/* Un tas (heap en anglais) est une structure de données qui permet de
 * d'accéder, avec une bonne complexité, à une liste d'éléments par
 * ordre croissant. L'objectif de cet exercice est d'implémenter un
 * algorithme de tri en utilisant une telle structure (heap sort ou
 * tri par tas).
 *
 * Vous avez à votre disposition la réalisation d'un tas fournie
 * par le fichier en-tête suivant.
 *
 * La description de l'algorithme de tri est fournie par le fichier
 * suivant : https://moodle.bordeaux-inp.fr/mod/resource/view.php?id=70672
 *
 * NB: le type size_t correspond à un entier.
 */

/********* DEBUT DU CODE A NE PAS MODIFIER **********************/
#ifndef HEAP_H
#define HEAP_H

#include <stdlib.h>

struct heap;

/* Retourne un tas vide
 */
struct heap * heap__empty();

/* Retourne le nombre d'éléments dans le tas h
 */
size_t heap__size(struct heap const * h);

/* Ajoute l'élément x au tas h
 * Retourne -1 en cas d'erreur, 0 sinon
 */
int heap__add(struct heap * h, int x);

/* Retire l'élément minimal du tas h et place la valeur retirée dans x
 * Retourne -1 en cas d'erreur, 0 sinon
 */
int heap__pick(struct heap * h, int * x);

/* Libère la mémoire allouée pour le tas h
 */
void heap__free(struct heap * h);

#endif // HEAP_H
/********** FIN DU CODE A NE PAS MODIFIER ***********************/


/* Mettre en œuvre un algorithme de tri par tas en utilisant les fonctions
 * données ci-dessus.
 *
 * L'algorithme est le suivant:
 * 1) Copie les size éléments de t dans un tas
 * 2) Recopie les éléments du tas dans t
 *
 * Votre fonction devra gérer correctement les cas d'erreur.
 * Elle retourne -1 si une erreur se produit et 0 sinon
 *
 * Remarque: il existe un algorithe plus efficace pour réaliser un tri par tas
 * qui utilise directement le tableau t comme un tas (algorithme "en place")
 */
int heap_sort(int t[], size_t size)
    ;

int main(void) {
  printf("Add your own tests here\n");
}
