#ifndef HEAP_H
#define HEAP_H

#include <stdlib.h>

struct heap;

/* Retourne un tas vide
 */
struct heap * heap__empty();

/* Retourne le nombre d'éléments dans le tas h
 */
size_t heap__size(struct heap const * h);

/* Ajoute l'élément x au tas h
 * Retourne -1 en cas d'erreur, 0 sinon
 */
int heap__add(struct heap * h, int x);

/* Retire l'élément minimal du tas h et place la valeur retirée dans x
 * Retourne -1 en cas d'erreur, 0 sinon
 */
int heap__pick(struct heap * h, int * x);

/* Libère la mémoire allouée pour le tas h
 */
void heap__free(struct heap * h);

#endif // HEAP_H
